/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOpenStackMachines implements OpenStackMachineInterface
type FakeOpenStackMachines struct {
	Fake *FakeInfrastructureV1beta1
	ns   string
}

var openstackmachinesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta1", Resource: "openstackmachines"}

var openstackmachinesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta1", Kind: "OpenStackMachine"}

// Get takes name of the openStackMachine, and returns the corresponding openStackMachine object, and an error if there is any.
func (c *FakeOpenStackMachines) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.OpenStackMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(openstackmachinesResource, c.ns, name), &v1beta1.OpenStackMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachine), err
}

// List takes label and field selectors, and returns the list of OpenStackMachines that match those selectors.
func (c *FakeOpenStackMachines) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.OpenStackMachineList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(openstackmachinesResource, openstackmachinesKind, c.ns, opts), &v1beta1.OpenStackMachineList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.OpenStackMachineList{ListMeta: obj.(*v1beta1.OpenStackMachineList).ListMeta}
	for _, item := range obj.(*v1beta1.OpenStackMachineList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested openStackMachines.
func (c *FakeOpenStackMachines) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(openstackmachinesResource, c.ns, opts))

}

// Create takes the representation of a openStackMachine and creates it.  Returns the server's representation of the openStackMachine, and an error, if there is any.
func (c *FakeOpenStackMachines) Create(ctx context.Context, openStackMachine *v1beta1.OpenStackMachine, opts v1.CreateOptions) (result *v1beta1.OpenStackMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(openstackmachinesResource, c.ns, openStackMachine), &v1beta1.OpenStackMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachine), err
}

// Update takes the representation of a openStackMachine and updates it. Returns the server's representation of the openStackMachine, and an error, if there is any.
func (c *FakeOpenStackMachines) Update(ctx context.Context, openStackMachine *v1beta1.OpenStackMachine, opts v1.UpdateOptions) (result *v1beta1.OpenStackMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(openstackmachinesResource, c.ns, openStackMachine), &v1beta1.OpenStackMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachine), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeOpenStackMachines) UpdateStatus(ctx context.Context, openStackMachine *v1beta1.OpenStackMachine, opts v1.UpdateOptions) (*v1beta1.OpenStackMachine, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(openstackmachinesResource, "status", c.ns, openStackMachine), &v1beta1.OpenStackMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachine), err
}

// Delete takes name of the openStackMachine and deletes it. Returns an error if one occurs.
func (c *FakeOpenStackMachines) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(openstackmachinesResource, c.ns, name, opts), &v1beta1.OpenStackMachine{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOpenStackMachines) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(openstackmachinesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.OpenStackMachineList{})
	return err
}

// Patch applies the patch and returns the patched openStackMachine.
func (c *FakeOpenStackMachines) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.OpenStackMachine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(openstackmachinesResource, c.ns, name, pt, data, subresources...), &v1beta1.OpenStackMachine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackMachine), err
}
